<template lang="html">
  <form class="" enctype="multipart/form-data" novalidate v-if="isInitial || isSaving">
    <div class="dropbox">
      <input type="file" multiple :name="upLoadFieldName" :disabled="isSaving" @change="handleFileChange" accept=".jpg, jpeg" class="input-file">
      <p v-if="isInitial">Drag your file(s) here to begin <br>or click to browse</p>
      <p v-if="isSaving">Uploading {{ fileCount().remaining }} / {{fileCount().total}}</p>
    </div>
  </form>
</template>

<script>
const STATUS_INITIAL = 0, STATUS_SAVING = 1, STATUS_SUCCESS = 2, STATUS_FAILED = 3

export default {

  methods: {
    handleFileChange(e) {
      this.fileChange(e.target.name, e.target.files)
      this.countFile(e)
    },
    countFile(e) {
      return this.$store.commit(
        'setFileCount',
        {fileCount: {remaining:0, total: e.target.files.length}}
      )
    },
    fileCount() {
      return this.$store.state.uploadState.fileCount
    },
    currentStatus(status) {
      return this.$store.commit(
        'setCurrentStatus',
        {currentStatus: status}
      )
    },
    resetForm() {
      return this.$store.commit('resetForm')
    },
    dispatchUpload(formData) {
      return this.$store.dispatch('uploadFiles', formData)
    },
    setFileList(fileList) {
      return this.$store.commit('setFileList', {fileList: fileList})
    },
    save(formData) {
      return this.dispatchUpload(formData)
    },
    fileChange(fieldName, fileList) {
      var files = Array(fileList.length)
      this.setFileList(fileList)
      const save = this.save

      if(!fileList.length) return

      this.currentStatus(STATUS_SAVING)
      for (var i = 0; i < fileList.length; i++) {
        files[i] = fileList[i]
      }
      (async (save, files, fieldName, store) => {
        for (var i = 0; i < files.length; i++) {
          const formData = new FormData()
          formData.append(fieldName, files[i])
          formData.append('filename', files[i].name)
          await save(formData).then(() => store.commit(
            'setFileCount',
            {fileCount: {remaining:i, total: files.length}}
          )).then(() => {
            if (i === files.length-1) {
              this.$store.dispatch('loadImages', {
                where: {is_processed: false},
                projection: {detected: 0, step_processed:0}
              }).then((response) => this.$store.commit('setCurrentStatus', {
                currentStatus: STATUS_SUCCESS
              }))
            }
          })
        }
      })(save, files, fieldName, this.$store)
    }
  },

  computed: {
    isInitial() {
      return this.$store.getters.getCurrentStatus === STATUS_INITIAL
    },
    isSaving() {
      return this.$store.getters.getCurrentStatus === STATUS_SAVING
    },
    isSuccess() {
      return this.$store.getters.getCurrentStatus === STATUS_SUCCESS
    },
    isFailed() {
      return this.$store.getters.getCurrentStatus === STATUS_FAILED
    },
    upLoadFieldName() {
      return this.$store.getters.getFieldName
    }
  },
  mounted() {
    this.resetForm()
  }
}
</script>
<style lang="scss" scoped>
  .dropbox {
    outline: 2px dashed grey;
    outline-offset: -10px;
    color: dimgray;
    padding: 10px;
    min-height: 200px;
    position: relative;
    cursor: pointer;
  }

  .input-file {
    opacity: 0;
    width: 100%;
    height: 200px;
    position: absolute;
    cursor: pointer;
  }

  .dropbox:hover {
    outline-color: lightblue;
  }

  .dropbox p {
    font-size: 1.3em;
    text-align: center;
    padding: 50px 0;
  }
</style>
